#
# Requires source'ing setup.tcl first
#

puts {
  ModelSim compile script
  Copyright 2008-2009, Impulse Accelerated Technologies, Inc.
  All rights reserved
}

# Compile out of date files
set time_now [clock seconds]
if { ! [info exists last_compile_time] } {
	set last_compile_time 0
}
foreach {library file_list} $library_file_list {
  vlib $library
  vmap work $library
}
if { $last_compile_time == 0 } {
	project compileall
} else {
	project compileoutofdate
}
set last_compile_time $time_now

# Load the simulation
eval [vsim $top_level]

set user_waveform 0
if { [file exists wave.do]} {
	set user_waveform 1
	puts "Loading wave.do..."
	source wave.do
}

if { ! $user_waveform && [llength $wave_patterns]} {
	# If waves are required
	noview wave
	foreach pattern $wave_patterns {
		add wave $pattern
	}
	configure wave -signalnamewidth 1
	foreach {radix signals} $wave_radices {
		foreach signal $signals {
			catch {property wave -radix $radix $signal}
		}
	}
	if $tk_ok {wm geometry .wave [winfo screenwidth .]x330+0-20}
	if $tk_ok {wave zoomrange 0ns 100ns}
}

# How long since project began?
if {[file isfile start_time.txt] == 0} {
  set f [open start_time.txt w]
  puts $f "Start time was [clock seconds]"
  close $f
} else {
  set f [open start_time.txt r]
  set line [gets $f]
  close $f
  regexp {\d+} $line start_time
  set total_time [expr ([clock seconds]-$start_time)/60]
  puts "Project time is $total_time minutes"
}

