puts {
  ModelSim setup script
  Copyright 2008-2009, Impulse Accelerated Technologies, Inc.
  All rights reserved
}

set wave_patterns {
	/*
}
set wave_radices {
	hexadecimal {data clk}
	hexadecimal {data sclk}
	hexadecimal {data reset}
}


# After sourcing the script from ModelSim for the
# first time use these commands to recompile.

proc r  {} {uplevel #0 source compile.tcl}
proc rr {} {global last_compile_time
            set last_compile_time 0
            r                            }
proc q  {} {quit -force                  }

#Does this installation support Tk?
set tk_ok 1
if [catch {package require Tk}] {set tk_ok 0}

# Prefer a fixed point font for the transcript
set PrefMain(font) {Courier 10 roman normal}

# This compiler-generated file sets $library_file_list and $top_level.
# Project file (.mpf) may override some settings.
source project_settings.tcl

# Open the first project file we find, warn about any others
set mpf ""
foreach f [glob -nocomplain "*.mpf"] {
	if { "$mpf" != "" } {
		puts "Warning: Ignoring ModelSim project file $f"
	} else {
		set mpf $f
	}
}
if { "$mpf" != "" } {
	project open $mpf
} else {
	puts "Warning: No ModelSim project file found!"
}

set os "unix"
if { [catch {exec uname -o} uname_output] } {
	# Not UNIX, assume it's Windows
	set os "windows"
} elseif { [string match -nocase "*cygwin*" $uname_output] } {
	set os "windows"
}
if { $os == "unix" } {
	project calculateorder
	puts ""
}

# User-defined post-setup script
if [file exists autorun.do] {
	puts "Running autorun.do..."
	source autorun.do
}

puts {
  Script commands are:
   r = Recompile changed and dependent files
 rr = Recompile everything
  q = Quit without confirmation
}

