--Legal Notice: (C)2010 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity user_logic_fim_module_classic_0 is 
        port (
              -- inputs:
                 signal clk : IN STD_LOGIC;
                 signal co_clk : IN STD_LOGIC;
                 signal fim_reset : IN STD_LOGIC;
                 signal p_cpu_proc_input_stream_addr : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal p_cpu_proc_input_stream_ce : IN STD_LOGIC;
                 signal p_cpu_proc_input_stream_read_n : IN STD_LOGIC;
                 signal p_cpu_proc_input_stream_reset_n : IN STD_LOGIC;
                 signal p_cpu_proc_input_stream_wdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal p_cpu_proc_input_stream_write_n : IN STD_LOGIC;
                 signal p_cpu_proc_output_stream_addr : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal p_cpu_proc_output_stream_ce : IN STD_LOGIC;
                 signal p_cpu_proc_output_stream_read_n : IN STD_LOGIC;
                 signal p_cpu_proc_output_stream_reset_n : IN STD_LOGIC;
                 signal p_cpu_proc_output_stream_wdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal p_cpu_proc_output_stream_write_n : IN STD_LOGIC;

              -- outputs:
                 signal p_cpu_proc_input_stream_rdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal p_cpu_proc_output_stream_rdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity user_logic_fim_module_classic_0;


architecture europa of user_logic_fim_module_classic_0 is
component fim_module is 
           port (
                 -- inputs:
                    signal clk : IN STD_LOGIC;
                    signal co_clk : IN STD_LOGIC;
                    signal fim_reset : IN STD_LOGIC;
                    signal p_cpu_proc_input_stream_addr : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal p_cpu_proc_input_stream_ce : IN STD_LOGIC;
                    signal p_cpu_proc_input_stream_read_n : IN STD_LOGIC;
                    signal p_cpu_proc_input_stream_reset_n : IN STD_LOGIC;
                    signal p_cpu_proc_input_stream_wdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal p_cpu_proc_input_stream_write_n : IN STD_LOGIC;
                    signal p_cpu_proc_output_stream_addr : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                    signal p_cpu_proc_output_stream_ce : IN STD_LOGIC;
                    signal p_cpu_proc_output_stream_read_n : IN STD_LOGIC;
                    signal p_cpu_proc_output_stream_reset_n : IN STD_LOGIC;
                    signal p_cpu_proc_output_stream_wdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal p_cpu_proc_output_stream_write_n : IN STD_LOGIC;

                 -- outputs:
                    signal p_cpu_proc_input_stream_rdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                    signal p_cpu_proc_output_stream_rdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
                 );
end component fim_module;

                signal internal_p_cpu_proc_input_stream_rdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);
                signal internal_p_cpu_proc_output_stream_rdata :  STD_LOGIC_VECTOR (31 DOWNTO 0);

begin

  --the_fim_module, which is an e_instance
  the_fim_module : fim_module
    port map(
      p_cpu_proc_input_stream_rdata => internal_p_cpu_proc_input_stream_rdata,
      p_cpu_proc_output_stream_rdata => internal_p_cpu_proc_output_stream_rdata,
      clk => clk,
      co_clk => co_clk,
      fim_reset => fim_reset,
      p_cpu_proc_input_stream_addr => p_cpu_proc_input_stream_addr,
      p_cpu_proc_input_stream_ce => p_cpu_proc_input_stream_ce,
      p_cpu_proc_input_stream_read_n => p_cpu_proc_input_stream_read_n,
      p_cpu_proc_input_stream_reset_n => p_cpu_proc_input_stream_reset_n,
      p_cpu_proc_input_stream_wdata => p_cpu_proc_input_stream_wdata,
      p_cpu_proc_input_stream_write_n => p_cpu_proc_input_stream_write_n,
      p_cpu_proc_output_stream_addr => p_cpu_proc_output_stream_addr,
      p_cpu_proc_output_stream_ce => p_cpu_proc_output_stream_ce,
      p_cpu_proc_output_stream_read_n => p_cpu_proc_output_stream_read_n,
      p_cpu_proc_output_stream_reset_n => p_cpu_proc_output_stream_reset_n,
      p_cpu_proc_output_stream_wdata => p_cpu_proc_output_stream_wdata,
      p_cpu_proc_output_stream_write_n => p_cpu_proc_output_stream_write_n
    );


  --vhdl renameroo for output signals
  p_cpu_proc_input_stream_rdata <= internal_p_cpu_proc_input_stream_rdata;
  --vhdl renameroo for output signals
  p_cpu_proc_output_stream_rdata <= internal_p_cpu_proc_output_stream_rdata;

end europa;

