#include "Fim_lib.h"
#include "global.h"

int generate_candidate(int g, int **candidate, int **next_candidate)
{   
   //variables
   int i, j,k,m;

  if (g == 1)
  { 
    //First generation, use all the possible item
    //Initialize the first generation candidate
    
    candidate_size = number_of_item;   //number of candidate
  
    for(i= 0;i< number_of_item; i++)
    {
     candidate[i][0] = i;
    }

    for(i= 0;i< number_of_item; i++)
    {
     next_candidate[i][0] = candidate[i][0];
    }

    next_candidate_size = candidate_size;
  }
  else if (g == 2)
  { 
    //Second generateion, generate the all combo of 2 items.
    int size = candidate_size*(candidate_size-1)/2;
    int idx= 0;//index of next_candidate

    for(j = 0; j < candidate_size;j++)
      for(k = j+1; k < candidate_size; k++)
      {
        next_candidate[idx][0] = candidate[j][0];
        next_candidate[idx][1] = candidate[k][0];
        //printf("generate potential candidate[%d] = (%d, %d)\n", idx,next_candidate[idx][0], next_candidate[idx][1]);
        idx++;
      }

    next_candidate_size = size;
  }
  else
    // For other generateions,g>= 3,generate the NO.g generation candidate
     {
       //2 steps in generation
        
         next_candidate_size = 0;//initalize to zero
       //First, generate possilbe candidates, based on (g-2) shared items between any two candiates
        for(i = 0;i< candidate_size;i++)
           for(j = i+1;j< candidate_size;j++)
              {
                int match = 0, miss = 0;
                for(k= 0;k <g-1;k++)
                  {  
                     int flag = 0;
                     for(m= 0;m <g-1;m++)
                     {
                        if(candidate[i][k] == candidate[j][m])
                           flag = 1;//find any match item in new candidate
                       
                     }
                     if (flag ==1) //find
                         match++;
                     else 
                         miss++;
                     if(miss ==2)//more than 2 item mismatch, not possible share the subset, so break
                           break;
                  }
                  if (match == g-2)//2 candidates share (g-2) items, possible new candidate 
                     {
                       //add a new candidate
                         int m= 0,n= 0;
                         int idx= 0;
                        while(idx!=g )
                          //while(n<g-1)
                         { if(n==g-1)
                               {
                                next_candidate[next_candidate_size][idx]= candidate[i][m];
                                //m++;
                                 }
                           else if(m==g-1)
                                {
                                next_candidate[next_candidate_size][idx]= candidate[j][n];
                                //n++;
                                }
                          else{
                             if(candidate[i][m] <candidate[j][n])
                                {
                                next_candidate[next_candidate_size][idx]= candidate[i][m];
                                m++;
                                }
                              else if(candidate[i][m]== candidate[j][n])
                                {
                                next_candidate[next_candidate_size][idx]= candidate[i][m];
                                m++;n++;
                                }
                              else
                                {
                                next_candidate[next_candidate_size][idx]= candidate[j][n];
                                n++;
                                }
                              }
                             idx++;
                            
                           }
                        next_candidate_size++;

                     }
                }

       //Second verify if there are g candidate appearances for a valid candidate,otherwise, delete
       
       int mark[next_candidate_size];//mark flag
       int times[next_candidate_size]; //appearance times for candidate
           for (i = 0; i< next_candidate_size; i++)
               {
               mark[i] = 1;//initialize everyone to be valid 
               times[i] = 1;//initialze to zero
               }
       for(i = 0;i< next_candidate_size;i++)//scan all generated candidate to count their appearance times
         for(j= i+1;j< next_candidate_size;j++)
           {
             int match = 0; 
            for(k= 0;k< g; k++)
             {  
               if(next_candidate[i][k] ==next_candidate[j][k])
                 match++;
               else
                 break;
             }
             if(match == g)
               times[i]+=1;
           }
         
       for (i = 0; i< next_candidate_size; i++)
          {
            if(times[i] != g)//invalid or redudant candidate
              mark[i] = 0; 
          }


       //Remove invalid next_candiate and resize the next_candidate list
                      int new_size = delete_invalid(next_candidate,mark,g,next_candidate_size);
                      next_candidate_size = new_size;
      }

  return 1;
}


int delete_invalid(int **candidate, int *mark, int size, int depth) 
{

// ARGUMENTS
// array: 2D potential candidates array
// mark: 1D mark array 
// depth: depth of the potential candidates array
// size: size of the candidates 
//
// RETURN
// depth of the candidates array

  int i, j, k;
  int new_depth = 0;

  for (i = 0; i < depth; i++) {
    if (!mark[i]) {
      for (j = i + 1; j < depth; j++) {
        if (mark[j]) {
          mark[i] = 1;
          mark[j] = 0;
          new_depth++;
          for (k = 0; k < size; k++)
            candidate[i][k] = candidate[j][k];
          break;
        }
      }

      // If we are at depth-1, then we cannot find 
      // valid array entry anymore 
      if (j == depth - 1)
        break;

    } else {
      new_depth++;
    }
  }

  //printf("Size of array = %d\n", new_depth);

  //for (i = new_depth; i < depth; i++)
  //  free(array[i]);

  return new_depth;
}

// prune the infrequent candidate according to support count
  int prune_candidate(int **next_candidate,int g, int *count,int threshold)
     {
       int i;
       int mark[next_candidate_size];//the infrequent mark for candidate
      for(i = 0; i < next_candidate_size; i++)
         {
           if(count[i]>= threshold) // count greater or eaqual to threshold
              mark[i] = 1;
           else
              mark[i]= 0;
         }
        
         int new_size = delete_invalid(next_candidate,mark,g,next_candidate_size);
         return new_size;
     }


//support counting
void support_counting(int **next_candidate,int g,int* count)
//Argeumets:
// array               :    input transaction
// next_candidate      :    the 2d candidate list pointer
// next_candidate_size :    number of candidate or the row number of next_candidate
// g                   :    generation number or the column number of next_candidate
// count               :    the return support count
{
  int i,j,k,m,l;
  int c;
  int t;
  int number_of_reload, candidate_per_load,remainder;

  //Mass storage
  int data[LENGTH_OF_MEM];//data storage
  int reg[LENGTH_OF_MEM]; //intermediate support storage
  int trans[LENGTH_OF_TRANSACTION];//input transaction data storage

  //Number of candidates for each load
  candidate_per_load = LENGTH_OF_MEM / g;
  //load number
  number_of_reload = (next_candidate_size*g) / (candidate_per_load*g);
  //remainder
  //remainder = (next_candidate_size*g) % (candidate_per_load*g);
  remainder = (next_candidate_size) % (candidate_per_load);
  for(l = 0;l< number_of_reload+1;l++)
  {
    int number_of_candidate = (l < number_of_reload) ? candidate_per_load : remainder;
        
    // Load candidate into data[] and clear reg[]
    for(j= 0;j<number_of_candidate; j++)
    { 
      #ifdef  PRINTOUT
      printf("candidate[%d]: ", j);
      #endif
      for(k = 0; k < g; k++)
      {
        data[j*g+k]= next_candidate[l*candidate_per_load+j][k];
        #ifdef PRINTOUT
        printf("%d ", data[j*g+k]);
        #endif
        reg[j*g+k] = 0;
      }
      #ifdef PRINTOUT
      printf("\n");
      #endif
    }

    // Read transaction and perform counting
    for(t = 0; t < NUMBER_OF_TRANSACTION; t++)//pointer to transaction number
    {
      // Load trans[] with one transaction data
      for(m = 0; m < LENGTH_OF_TRANSACTION; m++)
        trans[m] = array[t][m];

      for(i = 0; i < LENGTH_OF_TRANSACTION; i++)//pointer to item within transaction
      {
        for(c = 0; c < number_of_candidate; c++)//pointer to candidate
        {
          k = 0;
          while (k < g)
          {
            if ((trans[i] == data[c * g + k]))
            { 
              if (g == 1)
               reg[c]++;
              else 
              {//increment reg
                if (k == 0)
                  reg[c * g] = 1;
                else 
                  reg[c * g + k] += reg[c * g + k - 1];//could be 1 
              }

              break;
            } 
            else 
              k++;
          } 
        }
      }

      // One transaction is done and clear the intermediate reg[] 
      for(j = 0; j < number_of_candidate*g; j++)
      {
        if((g != 1) && (j % g != (g-1)))//reg store the final count for this transaciont
          reg[j] = 0;
      }
    } 

    //count is ready for output
    #ifdef PRINTOUT
    printf("************The %d generation*****************\n", g);
    #endif
    for(j= 0; j < number_of_candidate; j++) 
    {
      int offset = l * candidate_per_load;
      count[offset + j]= reg[j * g + g - 1];
      #ifdef PRINTOUT
      printf("count[%d] = %d\n", offset + j, count[offset + j]);
      #endif
    } 
  }
}


void generate_sourcefile(void)
{
  //FILE *fp;
  int i,j,k;
  int temp;
  //int **array;
 
//   array =  malloc(sizeof (int *) *NUMBER_OF_TRANSACTION );
//   if(array)
//  {
//   for(i= 0;i< NUMBER_OF_TRANSACTION; i++)
//     {
//      array[i] = malloc(sizeof (int) *LENGTH_OF_TRANSACTION);
//     }
//   }
  srand((unsigned) time((void *) 0));
  
 //Source data generation
  for(i= 0;i< NUMBER_OF_TRANSACTION;i++)
    for(j= 0;j< LENGTH_OF_TRANSACTION;j++)
     {// generate the no duplicate random number into array;
     redo:
        temp=  rand()%NUMBER_OF_ITEM;
        //printf("Current generated number is %d\n",temp);
        for(k= 0;k< j;k++)
          {
         if(array[i][k] == temp)//find duplicate, re-generate
          {
            //printf("Failed to create uniqute number, go to re-generate %d\n",temp);
            goto redo;}
           }
         array[i][j] = temp;
        //printf("Assign a[%d][%d] = %d\n",i,j,temp);
   
     }
// sort the array in ascending order

  for(i= 0;i< NUMBER_OF_TRANSACTION; i++)
    for(j= 0;j< LENGTH_OF_TRANSACTION; j++)
     for(k=j+1 ;k<LENGTH_OF_TRANSACTION; k++) 
     {
       //swap content if not ascending
       if (array[i][j]> array[i][k])
         {
           temp=  array[i][j];
           array[i][j]= array[i][k];
           array[i][k]= temp;
         }
      }  

  

//   fp = fopen(SOURCEFILE,"w+");
  
//   for(i= 0;i< NUMBER_OF_TRANSACTION; i++)
//    {
//     for(j= 0;j< LENGTH_OF_TRANSACTION;j++)
//       {
//        fprintf(fp,"%d ",array[i][j]);
//       }
//      if(i!= NUMBER_OF_TRANSACTION-1) fprintf(fp,"\n");
//    }

//     fclose(fp);
}

